%% TEST SF
clear all; close all; clc
for k=1:3
    
    if k==1
      filename='Test2.png';
      
    elseif k==2
         filename='Test3.png';
        
    elseif k==3
       filename= 'SF2.png';
    end
    
        
[X,~,~] = imread(filename);
X=X(:,4:end,:); % exclude the left vertical line in the images


%im=double(rgb2gray(X));
im=rgb2gray(X);
dim=min(size(im,1),size(im,2));
dimm=max(size(im,1),size(im,2));

thrisholdpixel=350;

while dimm >thrisholdpixel
    
    if size(im,1)>thrisholdpixel
        im=im(1:thrisholdpixel,:,:);
    end
    
    if size(im,2)>thrisholdpixel
        im=im(:,1:thrisholdpixel,:);
    end
    dimm=max(size(im,1),size(im,2));    
end

while dim <thrisholdpixel
    
    if size(im,1)<thrisholdpixel
        im(dim+1,:,:)=255*ones(1,size(im,2));
    end
    
    if size(im,2)<thrisholdpixel
        im(:,dim+1,:)=255*ones(size(im,1),1);
    end
    dim=min(size(im,1),size(im,2));
    
end

%%%
Ibw = ~im2bw(X,graythresh(im)); % make binary image
% Ifill = imfill(Ibw,'holes');   % remove holes
% Iarea = bwareaopen(Ifill,10);
% Ifinal = bwlabel(Iarea);
stat = regionprops(Ibw,'Area','MajorAxisLength','MinorAxisLength');

% convex hull
CH = bwconvhull(Ibw); 
ConxHull(k)=sum(sum(sum(CH)))*36/(thrisholdpixel^2);

% total colored area
total_area(k)=sum([stat.Area])*36/(thrisholdpixel^2);

% Edge length
Edge_length(k)=sum(2*sqrt(pi)*sqrt([stat.Area]))*6/thrisholdpixel;

imf=fftshift(fft2(im)); % Fourier transform of an image
impf=abs(imf).^2;  % power spectrum
N=size(im,1);
f=-N/2:N/2-1;
Pf=rotavg(impf); %% a rotational average of the power spectrum
f1=0:N/2;
%ARE_SP(t,m,k)=trapz(f1(end-150:end-20),Pf(end-150:end-20));

ARE_SP(k)=trapz(f1(10:end),Pf(10:end));

% hold on
% loglog(f1,Pf,'color',.35*[1 1 1],'LineWidth',2)
% ylim([1e2 1e14])
k
end


%
figure

subplot(1,4,1)
bar(ARE_SP);
ylabel('Area under curve')
xlabel('# elements')
set(gca,'xTick',[1 2 3],'xTickLabel',{'2','3','2C'})

subplot(1,4,2)
bar(total_area);
ylabel('total area(cm2)')
xlabel('# elements')
set(gca,'xTick',[1 2 3],'xTickLabel',{'2','3','2C'})

subplot(1,4,3)
bar(Edge_length);

ylabel('Edge length(cm)')
xlabel('# elements')
set(gca,'xTick',[1 2 3],'xTickLabel',{'2','3','2C'})

subplot(1,4,4)
bar(ConxHull);
ylabel('Convexhull(cm2)')
xlabel('# elements')
set(gca,'xTick',[1 2 3],'xTickLabel',{'2','3','2C'})
