clear all; close all; 

%cd('/Users/hadimaboudi/Projects/BET lab in Sheffield/Projects/concept of Zero/AnalysingStimuli/shapes/') % location file of patterns
%cd('/Users/hadimaboudi/Projects/BET lab in Sheffield/Projects/concept of Zero/AnalysingStimuli/shapes_Code')

cm1=1; cm2=1;cm3=1;cm4=1;cm5=1;cm6=1;

for t=1:3 % different shapes
    
    if t==1
    shapeoffigure='D';
    elseif t==2
    shapeoffigure='S';
    else
    shapeoffigure='C';
    end

for m=1:6 % different number
    
    clear lastnumber
    
    if m==1
        lastnumber=1;
    elseif m==2
        lastnumber=5;
    elseif m==6
        lastnumber=5;
    else   
        lastnumber=7;
    end
    
for k=1:lastnumber
    
    [t m k]
   
 
[X,~,~] = imread( [ shapeoffigure num2str(m) '_' num2str(k) '.png']); % reading the image

X=X(:,4:end,:); % exclude the left vertical line in the images


%im=double(rgb2gray(X));
im=rgb2gray(X);
dim=min(size(im,1),size(im,2));
dimm=max(size(im,1),size(im,2));

thrisholdpixel=350;

while dimm >thrisholdpixel
    
    if size(im,1)>thrisholdpixel
        im=im(1:thrisholdpixel,:,:);
    end
    
    if size(im,2)>thrisholdpixel
        im=im(:,1:thrisholdpixel,:);
    end
    dimm=max(size(im,1),size(im,2));    
end

while dim <thrisholdpixel
    
    if size(im,1)<thrisholdpixel
        im(dim+1,:,:)=255*ones(1,size(im,2));
    end
    
    if size(im,2)<thrisholdpixel
        im(:,dim+1,:)=255*ones(size(im,1),1);
    end
    dim=min(size(im,1),size(im,2));
    
end

%%%


%X=X(1:348,1:348,:);

imf=fftshift(fft2(im)); % Fourier transform of an image

impf=abs(imf).^2;  % power spectrum
N=size(im,1);
f=-N/2:N/2-1;

Pf=rotavg(impf); %% a rotational average of the power spectrum
f1=0:N/2;

ymin=.1E7;
ymax=.1E14;

figure(1)
if m==1
loglog(f1,Pf,'color',.1*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
PS1(cm1,:)=Pf;
cm1=cm1+1;
elseif m==2
loglog(f1,Pf,'color',.2*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

PS2(cm2,:)=Pf;
cm2=cm2+1;

elseif m==3
loglog(f1,Pf,'color',.35*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

PS3(cm3,:)=Pf;
cm3=cm3+1;

elseif m==4
loglog(f1,Pf,'color',.5*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

PS4(cm4,:)=Pf;
cm4=cm4+1;

elseif m==5
loglog(f1,Pf,'color',.65*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

PS5(cm5,:)=Pf;
cm5=cm5+1;

elseif m==6
loglog(f1,Pf,'color',.8*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

PS6(cm6,:)=Pf;
cm6=cm6+1;

end


figure(2)

if m==1
subplot(1,6,1)
loglog(f1,Pf,'color',.1*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
elseif m==2
subplot(1,6,2)
loglog(f1,Pf,'color',.2*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
elseif m==3
 subplot(1,6,3)
loglog(f1,Pf,'color',.35*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
elseif m==4
    subplot(1,6,4)
loglog(f1,Pf,'color',.5*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
elseif m==5
    subplot(1,6,5)
loglog(f1,Pf,'color',.65*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on
elseif m==6
    subplot(1,6,6)
loglog(f1,Pf,'color',.8*[1 1 1],'LineWidth',2)
ylim([ymin ymax])
hold on

end
end
end
end

%%
 legend('0','1','2','3','4','5','6');
figure(3)
loglog(f1,mean(PS1),'color',.2*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
hold on
loglog(f1,mean(PS2),'color',.4*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
hold on
loglog(f1,mean(PS3),'color',.55*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
hold on
loglog(f1,mean(PS4),'color',.7*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
hold on

loglog(f1,mean(PS5),'color',.85*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
hold on

loglog(f1,mean(PS6),'color',1*[1 0 0],'LineWidth',2)
ylim([ymin ymax])
legend('0','1','2','3','4','5','6');


